<?php
/**
 * Created by PhpStorm.
 * User: rafaelrapalo
 * Date: 24/04/14
 * Time: 09:00
 */

namespace Service;


use Doctrine\ORM\EntityManager;

class CalendarEntity
{

    private $entityManager;
    private $environment;
    private $calendarEntityFactory;

    public function __construct(EntityManager $entityManager, \Util\Utilities $environment,\Factory\CalendarEntity $calendarEntityFactory){
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->calendarEntityFactory = $calendarEntityFactory;
    }

    public function createCalendarEntity($compositeKey,$status,$user,$organization){




        if(!empty($compositeKey)){
            $idTableEntity = self::keyFy($compositeKey);
            $calendarEntities = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\CalendarEntity')->findOneBy(array('idTableEntity'=>$idTableEntity,'organization'=>$organization));

        }else{
            throw new \Exception("Null compositeKey.");
        }

            $entity = $this->calendarEntityFactory->createCalendarEntity($idTableEntity,$status,$organization, $user);
            $this->entityManager->persist($entity);
            $this->entityManager->flush();

        return $entity;
    }

    public function updateCalendarEntity($entity,$param){

        $status         = $param['STATUS'];
        $updatedBy      = $param['UPDATED_BY'];

        $factoryCalendarEntity = new \Factory\CalendarEntity($this->entityManager);
        $entity = $factoryCalendarEntity->updateCalendarEntity($entity,$status,$updatedBy);
        $this->entityManager->persist($entity);
        $this->entityManager->flush();

        return $entity;
    }

    public static function keyFy($keys){
        $key = '';
        foreach ($keys as $id => $value){
            if ($value instanceof \DateTime){
                $value = $value->format('Y-m-d h:i:s');
            }
            $key .= '_' . $id . '_' . $value;
        }
        return $key;
    }

}