<?php
namespace Zeedhi\DevOps\Model\Configurationmanager\Repositories;
use Zeedhi\DevOps\Util\Utilities as DevOpsUtilities;


class Product extends \Doctrine\ORM\EntityRepository {
    public function getProduct($filters = "",$organizationId, $limit = null, $offset = null) {
        $query = <<<SQL
			SELECT (SELECT RTRIM(XMLAGG(XMLELEMENT(E, U.USER_ID, ',').EXTRACT('//text()') ORDER BY U.USER_ID).GETCLOBVAL(), ',')
                      FROM ZH_USER_ALLOCATION U
                     WHERE U.PRODUCT_ID = P.ID) AS USER_ID,
                   (SELECT RTRIM(XMLAGG(XMLELEMENT(E, U.USER_ID, ',').EXTRACT('//text()') ORDER BY U.USER_ID).GETCLOBVAL(), ',')
                      FROM ZH_USER_ALLOCATION U
                     WHERE U.PRODUCT_ID = P.ID) AS ZH_USER,
                   P.ID, P.NAME, P.BASE_URL, P.DESCRIPTION, P.IS_ACTIVE, P.ORGANIZATION_ID,
                   P.VERSION, P.REVISION, P.BUILD, P.PROJECT_ID, P.PROJECT_NAME, P.PROJECT_STATUS, P.NUMBER_LTS_AVAILABLE
              FROM ( SELECT *
                       FROM (SELECT P.ID, P.NAME, P.BASE_URL, P.DESCRIPTION, P.IS_ACTIVE, P.ORGANIZATION_ID,
                                    P.VERSION, P.REVISION, P.BUILD, P.PROJECT_ID,
                                    U.USER_ID, U.USER_ID AS ZH_USER, PJ.NAME AS PROJECT_NAME, PJ.STATUS AS PROJECT_STATUS, P.NUMBER_LTS_AVAILABLE
                               FROM PRODUCT P
                               LEFT JOIN PROJECT PJ ON PJ.ID = P.PROJECT_ID
                               LEFT JOIN ZH_USER_ALLOCATION U ON U.PRODUCT_ID = P.ID
                              WHERE P.IS_ACTIVE = 'Y'
                              ORDER BY P.ID)
                      WHERE 1=1
                   $filters
                   ) P
             GROUP BY P.ID, P.NAME, P.BASE_URL, P.DESCRIPTION, P.IS_ACTIVE, P.ORGANIZATION_ID,
                      P.VERSION, P.REVISION, P.BUILD, P.PROJECT_ID, P.PROJECT_NAME, P.PROJECT_STATUS, P.NUMBER_LTS_AVAILABLE
             ORDER BY P.ID
SQL;

        $query = DevOpsUtilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getProductCallDevelopment($cdProduct){
        $query = <<<SQL

          SELECT PRO.CDPRODUTO AS ID, PRO.NMPRODUTO AS NAME,PROJECT_ID,CDPRODCOMP,CDPRODGRUP
            FROM PRODARVOREPROD PA
            JOIN PRODUTO PRO ON(PRO.CDPRODUTO = PA.CDPRODUTO AND (PROJECT_ID IS NOT NULL OR (CDPRODCOMP IS NOT NULL AND CDPRODGRUP IS NOT NULL)))
              WHERE PRO.CDPRODUTO = :cdProduct
SQL;

        $params = array(
            "cdProduct" => $cdProduct
        );
        $return = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return empty($return) ? null : $return[0];
    }

    public function getProductCallMotivo($cdProduct){
        $query = <<<SQL
     SELECT *
       FROM MOTICONT MOT
       JOIN CRM_RELACMOTIPROD CRM ON MOT.CDMOTICONT = CRM.CDMOTICONT
       JOIN PRODUTO PRO ON  PRO.CDPRODUTO = CRM.CDPRODUTO AND PRO.PROJECT_ID IS NOT NULL OR
                                                             (PRO.CDPRODCOMP IS NOT NULL AND PRO.CDPRODGRUP IS NOT NULL)
SQL;

        $params = array(
            "cdProduct" => $cdProduct
        );
        $return = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return empty($return) ? null : $return[0];
    }
    public function getProductsByServer($serverId, $filters = '') {
        $query = <<<SQL
        SELECT ID, NAME 
          FROM (
            SELECT PRO.ID AS ID, PRO.NAME AS NAME
              FROM PRODUCT PRO
              JOIN PRODUCT_FILES PF ON PRO.ID = PF.PRODUCT_ID
              JOIN PRODUCT_FILES_MNEMONIC PFM ON PF.ID = PFM.PRODUCT_FILES_ID
              JOIN MNEMONIC MNE ON MNE.ID = PFM.MNEMONIC_ID
              JOIN PRODUCT_SERVER PSE ON PSE.PRODUCT_ID = PRO.ID
              JOIN SERVER SER ON SER.ID = PSE.SERVER_ID
             WHERE SER.ID = :serverId
          GROUP BY PRO.ID, PRO.NAME)
         WHERE 1=1
      $filters
SQL;
        $params = array(
            "serverId" => $serverId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
}